#!/usr/bin/perl
# Genera cadenas de ADN aleatorias dado el número de cadenas y su longitud
use strict;
use warnings;

my $N; #numero de cadenas
my $M; #longitud de las cadenas (todas tienen la misma longitud)
my $semilla; #valor para inicializar la generacion aleatoria
my $DNA = '';

$N=<STDIN>;
$M=<STDIN>;
$semilla=<STDIN>;
print "$N";
print "$M";
# Inicia la generacion de valores aleatorios al valor dado por semilla, para que se pueda reproducir la entrada
# Se puede variar para que genere secuencias distintas
srand($semilla);

for (my $i=0 ; $i < $N ; ++$i) {
  $DNA= '';
  for(my $j=0; $j<$M;++$j) {
     $DNA.=randomnucleotide();
  }
  print "$DNA\n";
}
exit;

# randomnucleotide
#
# A subroutine to select at random one of the four nucleotides
#
# WARNING: make sure you call srand to seed the
# random number generator before you call this function.
sub randomnucleotide {
    my(@nucleotides) = ('A', 'C', 'G', 'T');
# scalar returns the size of an array.
# The elements of the array are numbered 0 to size-1
    return randomelement(@nucleotides);
}

# A subroutine to randomly select an element from an array
#
# WARNING: make sure you call srand to seed the
# random number generator before you call this function.
sub randomelement {
    my(@array) = @_;
    return $array[rand @array];
}
